//
// bidwatcher
// copyright (c) 1999 
// Trent McNair (trent@rmci.net)
// Tom McNair  (tmcnair@cyberhighway.net)
// 
// use of this code is restricted to the terms
// of the GPL, which should have been included in this
// distribution. If not, see www.gnu.org/copyleft/gpl.html.
// Here is the short version:
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
struct hostent *hp;
bool cancelPressed;
void CloseSocket(int sockIT)
{
   close(sockIT);
}
int set_nonblock(int fd)
{
    int flags = fcntl(fd, F_GETFL, 0);
    if (flags == -1)
        return -1;
    return fcntl(fd, F_SETFL, flags | O_NONBLOCK);
}
//////////////////////////////////////////////////////////////////////////////
//  Fetches an auction from ebay and stores the content (html tags are
//  removed) into <Buff>
//
//  Return codes are as follows:
//				  1 - success
//				  2 - connect failure 
//				  4 - timeout
//				  10 - cancelled by user
//////////////////////////////////////////////////////////////////////////////
int FetchHtml(char *WebPage, char *Buff, const char * theAddress, int sizeOfBuff, int timeOut)
{
   int    buffLength,recerr;
   int    port=80;
   int    socketID;
   char   lineBuff[1025];
   struct    sockaddr_in soc_in;
   //struct    timeval tv;
   //fd_set    sockList;
   strcpy(Buff, "");

   soc_in.sin_family=2;
   memcpy ((char *)&soc_in.sin_addr,theAddress,4);
   soc_in.sin_port = htons(port);
   socketID = socket(2, SOCK_STREAM, 0);
   if (socketID < 0) return 2;
   
   if (::connect(socketID, (struct sockaddr *)&soc_in, sizeof (soc_in)) < 0)
      return 2;
   set_nonblock(socketID);   
   // send our request for the html page.
   send(socketID, "GET ", 4, 0);
   send(socketID, WebPage, strlen(WebPage), 0);
   send(socketID, " HTTP/1.0\n", 10, 0);
   send(socketID, "\n", 1, 0);

   buffLength = 0;

   int counter = 0;
   bool goodcall = TRUE;
   QTime the_time; 
   the_time.start();
   while ( goodcall )
   {
      usleep(600);
      counter++;
      if ( cancelPressed ) return 10;
	   if ( counter == 5 )
	   {
	      counter = 0;
         qApp->processEvents();
         if ( the_time.elapsed() > timeOut )
         {
            CloseSocket(socketID);
            return 4;
         }
      }
      recerr = recv(socketID, lineBuff, 1024, 0);
      if ( recerr < 0 )
      {
         if ( errno != EWOULDBLOCK )
         {
		       goodcall = FALSE;
			    break;
         }
         goodcall = TRUE;
      }
	  else if ( recerr == 0 ) break;
	  else
	  {
         if ( (buffLength + recerr) < sizeOfBuff )
         {
             buffLength = buffLength + recerr;
		       strncat(Buff, lineBuff, recerr);
			    goodcall = TRUE;
         }
         else break;
      }
   }
   CloseSocket(socketID);
   // there is a slight chance that the web page was _exactly the
   // same size as the buffer, so we will  fix that:
   Buff[sizeOfBuff - 1] = '\0';
   if ( !goodcall ) return 2; 
   return 1; 
} 
